#include<iostream>
#include<algorithm>
using namespace std;
int S(int x){
    return x*x/2+x/2+x%2;
}
int N,l;
int index_of(int a,int b){
    /*if(a>N-b){
        int m=(N+1)>>1;
        a=m+m-a;
        b=m+m-b;
    }*/
    if(b>a) swap(a,b);
    return b+l-S(N-a);
}
int main(){
    int M;
    cin>>N>>M;
    l=S(N);
    bool* prohodno=new bool[l];
    bool* sa_ledom=new bool[l];
    for(int i=0;i<l;i++)
        sa_ledom[i]=prohodno[i]=false;
    for(int i=0;i<M;i++){
        int a,b,c;
        cin>>a>>b>>c;
        a--;
        b--;
        prohodno[index_of(a,b)]=true;
        sa_ledom[index_of(a,b)]=(bool)c;
    }
    int p,k;
    cin>>p>>k;
    p--;
    k--;
    int izlaz=0;
    bool stanje=false;
    int prevTacka=-1;
    int tacka=p;
    int lookFrom=0;
    while(tacka!=k){
        bool pronadjenPut=false;
        int last=0;
        for(int i=lookFrom;i<N;i++)
            if(prohodno[index_of(tacka,i)]) last=i;
        for(int i=lookFrom;i<N;i++){
            if(!prohodno[index_of(tacka,i)]) continue;
            if(stanje==sa_ledom[index_of(tacka,i)]){
                pronadjenPut=true;
                tacka=i;
                continue;
            }
            if(!pronadjenPut&&i==last){
                stanje=!stanje;
                izlaz++;
                tacka=last;
            }
        }
        if(!pronadjenPut){
            if(prevTacka!=-1){
                lookFrom=tacka;
                tacka=prevTacka;
            }else{
                izlaz=-1;
                break;
            }
        }
    }
    cout<<izlaz<<endl;
    return 0;
}